=== modified file 'NEWS'
--- NEWS	2009-04-21 23:54:16 +0000
+++ NEWS	2009-04-24 18:17:16 +0000
@@ -38,6 +38,9 @@
 * End-Of-Line content filters are now loaded correctly.
   (Ian Clatworthy, Brian de Alwis, #355280)
 
+* Fix TypeError in running ``bzr break-lock`` on some URLs.
+  (Alexander Belchenko, Martin Pool, #365891)
+
 * ``bzr send`` works to send emails again using MAPI.
   (Neil Martinsen-Burrell, #346998)
 

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2009-04-07 12:41:42 +0000
+++ bzrlib/tests/test_ui.py	2009-04-24 13:30:48 +0000
@@ -221,6 +221,11 @@
         factory = TextUIFactory(None, None, None)
         self.assert_get_bool_acceptance_of_user_input(factory)
 
+    def test_text_factory_prompt(self):
+        # see <https://launchpad.net/bugs/365891>
+        factory = TextUIFactory(None, StringIO(), StringIO())
+        factory.prompt('foo %2e')
+
     def test_text_factory_prompts_and_clears(self):
         # a get_boolean call should clear the pb before prompting
         out = _TTYStringIO()

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2009-04-07 11:51:05 +0000
+++ bzrlib/ui/__init__.py	2009-04-24 15:49:33 +0000
@@ -217,8 +217,14 @@
         return username
 
     def prompt(self, prompt, **kwargs):
-        """Emit prompt on the CLI."""
-        prompt = prompt % kwargs
+        """Emit prompt on the CLI.
+        
+        :param kwargs: Dictionary of arguments to insert into the prompt,
+            to allow UIs to reformat the prompt.
+        """
+        if kwargs:
+            # See <https://launchpad.net/bugs/365891>
+            prompt = prompt % kwargs
         prompt = prompt.encode(osutils.get_terminal_encoding(), 'replace')
         self.clear_term()
         self.stdout.write(prompt)

